package semafori;
/**
 * Classe dei thread ascensori.
 *
 * @author Boschi Alessandro
 * @author Fabrizi Andrea
 * @author Ronchi Alessandro
 * @author Scozzoli Angelo
 */
public class ascensore extends Thread
{
    public Semaforo_asc sem;
    public int id;
    public int cambio_dir;

    /** Costruttore della classe ascensore
     * @param sg semaforo globale
     * @param id_asc id di riconoscimento dell'ascensore
     */

    public ascensore(Semaforo_asc sg, int id_asc)
    {
	sem=sg;
	id=id_asc;
	sem.postiascensore[id]=5;
	cambio_dir=2;
    }
    /**
     * L'ascensore fa una scansione del piano prima nella sua direzione,
     * poi nella direzione opposta, e  se non trova nessuno allora si mette
     * in pausa.
     * Questo procedimanto viene regolato tramite la variabile "cambio_dir"
     * che memorizza quante volte l'ascensore ha cambiato la proria direzione.
     */
    public void run()
    {
	int piano_tmp;
	while(true)
	    {
		if (cambio_dir==2)
		    {
			sem.asc_init();
			cambio_dir=0;
		    }
		else
		    {
			if (sem.asc_direz[id]==sem.direz_su)
			    {
				piano_tmp=(sem.n_piani-1);
				while((piano_tmp!=(sem.pianoascensore[id]-1)) &&
				      (sem.piani_count[sem.direz_su][piano_tmp]==0) &&
				      (sem.piani_count[sem.direz_giu][piano_tmp]==0) &&
				      (sem.uscita_count[id][piano_tmp]==0))
				    piano_tmp--;
				if  (piano_tmp!=(sem.pianoascensore[id]-1))
				    {
                                         if ((piano_tmp==sem.pianoascensore[id])&&(sem.piani_count[sem.direz_su][piano_tmp]==0))
                                                {
                                                      sem.asc_direz[id]=sem.direz_giu;
                                                }
                                                else
                                                {
						      sem.asc_muovi(piano_tmp,this);
						      cambio_dir=0;
                                                }
				    }
				else
				    {
					cambio_dir++;
					sem.asc_direz[id]=sem.direz_giu;
				    }
			    }
			else
			    {
				piano_tmp=0;
				while((piano_tmp!=(sem.pianoascensore[id]+1)) &&
				      (sem.piani_count[sem.direz_su][piano_tmp]==0) &&
				      (sem.piani_count[sem.direz_giu][piano_tmp]==0) &&
				      (sem.uscita_count[id][piano_tmp]==0))
				    piano_tmp++;
				if (piano_tmp!=(sem.pianoascensore[id]+1))
				    {
					 if ((piano_tmp==sem.pianoascensore[id])&&(sem.piani_count[sem.direz_giu][piano_tmp]==0))
                                                {
                                                      sem.asc_direz[id]=sem.direz_su;
                                                }
                                                else
                                                {
						      sem.asc_muovi(piano_tmp,this);
						      cambio_dir=0;
                                                }
				    }
				else
				    {
					cambio_dir++;
					sem.asc_direz[id]=sem.direz_su;
				    }
			    }
		    }//end else
	    }//end while
    }// end run
}// end class
